#include <stdlib.h>

#include "configure.h"
//stuw(ff)
#include "slang.h"
#include "stuff.h"
//structs
#include "s_androids.h"
//functions
#include "f_dvd.h"
#include "f_map.h"


#include "teleport.h"
char *wall = "`' : ? % * ...:; ;:^^#~~::H::>>< =-=+|##KH**.'wDSdfsfd";
extern int d(int);
extern char f_ch();
//
struct map; 
struct map {
	struct map *next, *prev; 
	char *caption;
	int length, n_andro;
	struct register_andro *first, *last, *jmp;
	int color;
	int y;
};

struct earthsee {	//
	struct map *first, *last;
	int n_maps;
};


//	------------------	-----------------	-------------------	//
char fch()
{
	char c = d(94) + 33;  
	return (c != '%' ) ? c : fch();
}

//	------------------	-----------------	-------------------	//
int fcolor(int forbid)
{
	int color;

	switch(d(5)) {
	case 1 :
		color = White;
		break;
	case 2 :
		color = Red;
		break;
	case 3 :
		color = Green;
		break;
	case 4 :
		color = Cyan;
		break;
	default :
		color = Blue;
	}
	if (color == forbid) 
		return fcolor(forbid); 
	return color;
}

//	------------------	-----------------	-------------------	//
struct map *init_map()
{
	struct map *m = malloc(sizeof(struct map));
	m->caption = 0;
	m->y = d(3);
	m->first = m->last = 0;
	m->y = m->length = 0;
	m->prev = 0;
	m->next = 0;
	m->n_andro = 0;
	return m;
}

//	------------------	-----------------	-------------------	//
void add_map(struct earthsee *roke)
{
	if (!roke->first) {
		roke->first = roke->last = init_map();
		roke->first->color = (d(2)-1) ? Blue : Cyan;
	} else {
		roke->last->next = init_map();
		roke->last->next->prev = roke->last;
		roke->last = roke->last->next;
		roke->last->color = fcolor(roke->last->prev->color);
	}
}
	
//	------------------	-----------------	-------------------	//
int maplen(struct map *m)
{
	return m->length;
}

//	------------------	-----------------	-------------------	//
void fill_map(struct map *m)
{
	int l = (d(2) + d(1)) * sl_screen_width;
	int mem = l;
	m->caption = malloc(sizeof(char) * (l+1));
	m->length = l;
	for (m->caption[l] = '\000'; l+1;l--) 
		m->caption[l] = fch();	
		
	m->caption[mem-1] = '%';
	m->caption[0] = '%';
}

//	------------------	-----------------	-------------------	//
struct earthsee *init_earthsee(int n)
{
	struct earthsee *roke = malloc(sizeof(struct earthsee));
	roke->n_maps = n;
	roke->first = roke->last = 0;
	while (n--) {
		add_map(roke);
		fill_map(roke->last);
	}
	return roke;
}

//	------------------	-----------------	-------------------	//
struct map *rand_map(struct earthsee *ea)
{
	struct map *t = ea->first;
	int n = d(ea->n_maps);
	for (;--n; t = t->next);
	return t;
}

//	------------------	-----------------	-------------------	//
//	putting androids into random map
void put_androids(struct earthsee *ea, struct register_andro *joe)
{
	for (;joe; joe = joe->next) { 
		joe->place = rand_map(ea);
		joe->who->x =  15 + d(maplen(joe->place) - dvdlen(joe->who->dvd) -10);
		joe->who->curse = (d(2)-1) ? right : left;
		joe->who->y = Map_height - dvdhei(joe->who->dvd);
	}
}

//	------------------	-----------------	-------------------	//
void sortmee(struct register_andro *mee)
{
	struct register_andro *m = malloc(sizeof(struct register_andro));
	m->who = mee->who;
	m->next = 0;
	m->place = mee->place;
	m->place->n_andro++;
	if (!mee->place->first)
		mee->place->first = mee->place->last = m;  
	else {
		mee->place->last->next = m;
		mee->place->last = m;
	}
}

//	------------------	-----------------	-------------------	//
// putting androids to the list inside 'struct map'
void sort_androids(struct register_andro *joe)
{
	for (; joe; joe = joe->next)	
		sortmee(joe);
}

//	------------------	-----------------	-------------------	//
// do you like small functions ?
static void if_is_draw(int sx, int ex, struct register_andro *joe)
{
	int width = dvdlen(joe->who->dvd);
	struct frames *dvd = joe->who->dvd;
	if (joe->who->x + width > sx && joe->who->x < ex) {
		int ex2 = joe->who->x + width, x;
		if (joe->who->x < sx) {
			x = -1*dvdlo(dvd); 
			putlo(dvd,sx - joe->who->x);
		} else if (ex2 > ex) { 
			putro(dvd, ex2 - ex);		// ext2 fs rulez ;)  
			x = sl_screen_width - (width - dvdro(dvd)); 
		} else  
			x = (joe->who->x - sx);
		/*sl_color(Red);
		sl_goto(x + 3, joe->who->y-2);
		sl_addstr(joe->who->name);*/
		draw(dvd, x, joe->who->y, joe->who->curse);
	}
}

//	------------------	-----------------	-------------------	//
static struct register_andro *is(struct register_andro *joe, int  sx, int ex)
{
	int width = dvdlen(joe->who->dvd);
	if (joe->who->x + width > sx && joe->who->x < ex)
		return joe;
	return 0;
}

//	------------------	-----------------	-------------------	//
static int between(struct register_andro *old,  struct register_andro *new, int x)
{
	if (old)  {
		int ox = old->who->x + dvdlen(old->who->dvd)/2; // old x
		int nx = new->who->x + dvdlen(new->who->dvd)/2; // new x
		nx = (x < nx) ? nx - x : x - nx;
		ox = (x < ox) ? ox - x : x - ox;
		return (ox < nx) ? 0 : 1;	
	}
	return 1;
}

//	------------------	-----------------	-------------------	//
struct register_andro *anyone(struct map *way, int sx, int ex, int x)
{
	struct register_andro * jumper, *src, *jmp;
	for (src = 0, jumper = way->first; jumper; jumper = jumper->next)  {
		jmp = is(jumper, sx, ex);
		if (jmp) 
			if (between(src, jmp, x))
				src = jmp;
	}
	return src;
	
}

//	------------------	-----------------	-------------------	//
void draw_wall(int x, int y, unsigned  int h)
{
	char *c = wall;
	if (h > strlen(wall))
		h = strlen(wall);
	do{
		sl_goto(x, y-h);
		sl_putch(*c++);
	} while (h--);
		
}

//	------------------	-----------------	-------------------	//
void draw_cabine(int x, int y, int c1, int c2)
{
	int h = T_height;
	#define P 4
	#define T1 '*'
	#define T2 '.'
	#define T3 '!'
	do
		if (d(P) == P  && x % (h +1) < 7 ){
			sl_goto(x, y-h);
			sl_color((d(2)-1) ? c1 : c2);
			sl_putch((d(3)-1) ? (d(2)-1 ? T1 : T2) : T3);
		}
	while (h--);
	sl_goto(x, y);
	sl_color(c1);
		
}

//	------------------	-----------------	-------------------	//
void draw_map(struct map *way, int sx, int ex, int y)
{
	struct register_andro * jumper;
	char *l = way->caption+sx;
	int i = 0, leng = way->length;
	int first = (way->prev) ? 0 : 1, last = (way->next) ? 0 : 1;
	
	sl_color(way->color);
	
	sl_goto(i,y);
	
	do {
		if (!first && sx + i > to_T && sx + i <= to_T+T_length) 
			draw_cabine(i, y, way->color, way->color+1);
		if (!last && sx + i > leng - to_T -T_length && sx + i <= leng - to_T) 
			draw_cabine(i, y, way->color, way->color+1);
		else if (*l == '%') {
			draw_wall(i, y,sl_screen_width - (sl_screen_height -y));
			sl_goto(i, y);
		} 
		sl_putch(*l++);
	} while (++i <= sl_screen_width);
	
	for (jumper = way->first; jumper; jumper = jumper->next) 
		if_is_draw(sx, ex, jumper);
}


//	------------------	-----------------	-------------------	//
struct map *retf(struct earthsee *roke)
{
	return roke->first;
}

//	------------------	-----------------	-------------------	//
struct map *p_map(struct map *way)
{
	return way->prev;
}

//	------------------	-----------------	-------------------	//
struct map *n_map(struct map  *way)
{
	return way->next;
}

//	------------------	-----------------	-------------------	//
int mapcolor(struct map  *way)
{
	return way->color;
}

