/* slang.c */
#define C_BLACK "black"
#define C_GRAY "gray"
#define C_RED "red" 
#define C_LIGHTRED "brightred"
#define C_GREEN "green"
#define C_LIGHTGREEN "brightgreen"
#define C_BROWN "brown"
#define C_YELLOW "yellow"
#define C_BLUE "blue"
#define C_LIGHTBLUE "brightblue"
#define C_MAGENTA "magenta"
#define C_LIGHTMAGENTA "brightmagenta"
#define C_CYAN "cyan"
#define C_LIGHTCYAN "brightcyan"
#define C_LIGHTGRAY "lightgray"
#define C_WHITE "white"
enum {
	sl_key_esc = 27,
	sl_key_first = 0x100,
	sl_key_up, sl_key_down, sl_key_left, sl_key_right,
	sl_key_pgup, sl_key_pgdn, sl_key_del, sl_key_home,
	sl_key_end, sl_key_f0 = 0x200
};
extern int sl_screen_width, sl_screen_height;
#define sl_key_f(a) (sl_key_f0 + (a))

enum {
	Black = 1,
	Gray,
	
	Blue,
	Lblue,
	
	Green,
	Lgreen,
	
	Cyan,
	Lcyan,
	Fcyan,
	
	Red,
	Lred,
	
	White,
	Lwhite,
	
	Mag,
	

	Active,
	Passive,

	Cabine
	

}; 


void sl_cls(void);
void sl_addstr_fill_alt(const char *s, int n, int c1, int c2);
void sl_addstr_alt(const char *s, int n, int c1, int c2);
void sl_init(void);
void sl_goto(int x, int y);
void sl_frame(int x, int y, int w, int h);
void sl_putch(int c);
void sl_addstr(const char *c);
void sl_addstrn(const char *c, int n);
void sl_addstrn_fill(const char *c, int n);
int sl_strlen_alt(const char *s);
void sl_color(int c);
void sl_refresh(void);
void sl_fini(void);
void sl_die(const char *msg);
void sl_fill(int c, int x, int y, int w, int h);
int sl_getch(void);
