#include <stdlib.h>
#include "slang.h"
#include "ematrix.h"
extern char *strchr(char*, int);
extern int d(int);

//	-----------------	----------------	------------------	//
char f_ch() 
{
	char z = d(93) + 33; 			//the first char have number 33
		return z;
}

//	-----------------	----------------	------------------	//
int check_shine() 
{
	int shine = 0;
	if (d(SHINE_PROP) == SHINE_PROP) {
		shine++; 
		if (d(3) == 3)
			shine++;
	}
	return shine;
}

//	-----------------	----------------	------------------	//
void setl(line *em, int set, int n)
{
	if (set) {
		int i = 0;
		char *c = malloc(n*sizeof(char));	
		em->caption = c;
		do
			*(c++) =  ' ';
		while (++i < n);
	}
	em->cut = em->could = em->y = em->len = 0;
	em->draw = 1;
	em->shine = check_shine();
}

//	-----------------	----------------	------------------	//
void ver_grow(line *em) 
{
	#define _T5 8 
	#define _T4 10
	#define _T3 16 
	#define _T2 18 
	#define _T1 22 
	int prob = -1;
	
	switch (em->len) {
	case _T1 :
		prob = 70;
		break;
	case _T2 :
		prob = 60;
		break;
	case _T3 :
		prob = 43;
		break;
	case _T4 :
		prob = 20;
		break;
	case _T5 :
		prob = 5;
		break;
	}
	
	if (d(100) <= prob)  
		em->cut =  1;
}

//	-----------------	----------------	------------------	//
void verify(line *em)
{
	int n = sl_screen_height;
	if (!em->could) {
		em->could = (d(DRAW_PROP) == 1) ? 1 : 0;
		return;
	}
	ver_grow(em);
	if (em->draw) {
		em->caption[em->y++] = f_ch(0);
		em->len++;
	} 
	if (em->cut)
		em->caption[em->y - em->len--] = ' ';

	if (em->y == n) {
		em->draw = 0;
		em->cut = 1;
	}
	if (!em->len) {
		setl(em,0, n);		
		if (d(3)-2) {
			em->could = 1;
			em->shine = check_shine();
		}
	}
}
	
//	-----------------	----------------	------------------	//
void draw_ematrix(int sx, int sy, int h, int len, line *first, line *last)
{
	line *em = first;
	int i = 0, y;
	int dark = 0;
	int nc = Gray, sc = Lwhite;
	char *tab[len];
	char c;
	
	do {
		verify(em);
		tab[i] = em->caption;
	} while (++i < len && em++ != last); 
//	nc = Black;	//	for snow efect
//	sc = Lwhite;	//	for snow efect
	if (dark) 
		sl_color(Black);
	else
		sl_color(nc);
	
	for (y = sy; y <= h; y++) {
	
		em =  first;
		sl_goto(sx,y);
		i = 0;
		do {
			c =**(tab+i); 
			if (i +1 < len  && em->shine && *(*(tab+i) + 1) == ' ' 
				&& em->shine == 2) {
					if (!dark) {
						sl_color(sc);
//						if (c != ' ')		//for snow efect
//							c = '@';			//for snow efect
						
					}	
			} else {
				if (!dark)
					sl_color(nc);
			}
			sl_putch(c);
			(*(tab +i))++;
		} while (em++ != last  && i++ < len);
	}
}

