#include <unistd.h>
#include <stdlib.h>
#include "slang.h"

extern int d(int);

//	-------------------	------------------	-------------------	//
static void cll(int y)
{
	int x = 0;
	sl_goto(x, y);
	while (x++ < sl_screen_width)
		sl_putch(' ');
}

//	-------------------	------------------	-------------------	//
static void achar(char *src , int of, int x, int y)
{
	int i, oy = 0;
	int w = d(40)*60;
	char c = *(src+of);
	while (oy <= y) {	
		if (oy)
			cll(oy-1);
		sl_goto(x + of,oy++);
		sl_putch(c);
		sl_goto(x,y);
		for (i = 0; i < of; i++)
			sl_putch(src[i]);
		sl_goto(0,0);
		sl_refresh();
		usleep(w);
	}
}

//	-------------------	------------------	-------------------	//
static int astring_xy(char *src, int x, int y)
{
	char *tmp = src;
	
	int ox = 0;
	
	for (;*tmp; tmp++, ox++) {
		if (sl_getch())
			return 0;
		if (*tmp == ' ')
			continue;
		achar(src, ox, x, y);
	}
	sl_refresh();
	return 1;
}

//	-------------------	------------------	-------------------	//
static int astring(char *src)
{
	int x = (sl_screen_width - strlen(src)) /2;
	int y = sl_screen_height/2;
	return astring_xy(src, x, y);
}

//	-------------------	------------------	-------------------	//
void draw_cur(int x, int y, int color)
{
		sl_goto(x,y);
		sl_color(color);
		sl_putch(' ');
		sl_goto(0,0);
		sl_refresh();

}

int skeyboard(char *what, int no, int sh, int x, int y)
{
	if (what) {
		int sx = x;
		int cx = x, cy = y;
		while (*what) {
			if (*what == '\n') {
				what++;
				y++;
				x = sx;
			} if (*(what+1) == '\n') {
				cx = sx;
				cy = y+1;
			} else 
				cx++;
			if (*what == '_') {
				sl_color(sh);
				what++;
			} else
				sl_color(no);
			usleep(((rand() % 10 )+1)*5007);
			sl_goto(x++,y);
			sl_putch(*what++);
			draw_cur(cx, cy, Active);
		}
		draw_cur(x, y, no);
		return 1;
	}
	return 0;
}

void intro()
{
#define XXX (sl_screen_width-strlen(title))/2 + 8
#define YYY sl_screen_height - 3
	char *title = "t h e   Q u e n d i",
		*name = "_G r z e g o r z   _M o s k a l",
		*nick = "[ _e l d e v a r t h ]";
	int shine = Lwhite;
	int normal = White;
	
	sl_color(Active);
	if (astring(title)) { 
		skeyboard(name, normal, shine, XXX, YYY);
		
		skeyboard(nick, normal, shine, XXX+4, YYY+1);
		
		sleep(2);
	}
}
