#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>

#include "s_rpass.h"

#include "f_rpass.h"
#include "f_pass.h"

extern struct word *prev_word(struct base*, struct word*);
extern int d(int hm);
extern int observ;
struct word *rwdefin(int state, char *s, struct base *b);

char *name = 0;		//something what makes from sentence question;
char *sq = 0;		//something what makes from sentence question;
int mood, is_question;
struct passbot *crosser;
struct base *brosser;
struct word *verb;



char *ask_word[] = {
	"ask_words", "kim", "jak", "czemu", "co", 
	"ile", "kiedy", "gdzie", "czy", "kto", 
	"bys", "?", "!"};

enum {
	_BYC = 0, JESTEM, JESTES, JEST, JESTESMY, JESTESCIE, SA
};
static char *be_words[] = {
	"byc","jestem","jeste","jest",
	"jestemy","jestecie","s", "|"
};
enum {
	_MIEC = 0, MAM, MASZ, MA, MAMY, MACIE, MAJA
};
static char *have_words[] = {
	"miec", "mam", "masz", "ma",
	"mamy", "macie", "maj","|"
};
char *person_words[] = {
	"osoby", "ja","ty","on","ona",
	"my","wy","oni", "one","|"
};	// ono :)





//////////////////////////////////////////////////////////////////////////////////////////////
//			 : ) 
//////////////////////////////////////////////////////////////////////////////////////////////


//	   .........................................		//
struct list * init_list()
{
	struct list *l = (struct list *)malloc(sizeof(struct list));
	l->first = l->last = 0;
	l->n = 0;
	return l;
}


//	   .........................................		//
static void add_word(char *s, struct list  *l)
{
	struct w *last = malloc(sizeof(struct w));
	last->next = 0;
	last->caption = s;
	last->miec = last->state = last->byc = last->osoba = 0;
	if (!l->first) 
		l->first = l->last = last;
	else {
		l->last->next = last; 
		l->last = l->last->next;
	}
	l->n ++;
}


//	   .........................................		//
void divide_sentence(struct list *l, char *s)
{
	char *nw;	//new word :) n letters
	char *jmp = s;
	int n;
	
	do {
		for (n = 0, jmp = s; *jmp && !isspace(*jmp); jmp++, n++);
		nw = malloc(sizeof(char) * n + 1);
		smalling(s);
		strncpy(nw, s, n);
		nw[n] = '\000';
		add_word(nw, l);
		s += (*jmp) ? n+1: n;
	} while (*s);

	return;
}


//	   .........................................		//
static char *rch(char *s)
{
	if (s)
		return " ";
	return "";
}


//	   .........................................		//
char *rwhole(char *src, char *s1, char *s2, char *s3)
{
	int len = rlen(src);
	src = realloc(src, (len + rlen(s1) + rlen(s2) + rlen(s3) + 4));
	sprintf(src+len,"%s%s%s%s%s", rstr(s1),rch(s1), rstr(s2),rch(s2), rstr(s3));
	return src;
}


//	   .........................................		//
int find_person()
{
	char *root = malloc(sizeof(char) * 3);
	int i;
	struct word *www;
	sprintf(root,"%2.2s",verb->what);
	for (www = prev_word(brosser, verb),  i = 0; www && strstr(www->what, root); 
		i++, www = prev_word(brosser, www));
	do
		switch (i) {
		case 0:
			return JA;
		case 1:
			return TY;
		case 2:
			return ON;
		default :
			i -= 3;
		}
	while (i >= 0);
	return 0;
}


//	   .........................................		//
char *fit_verb()
{
	int person = find_person();
	if (person == JA)
		verb = verb->next;
	if (person == TY)
		verb = prev_word(brosser,verb);
	return verb->what;
}


//	   .........................................		//
char *add_ch(char *s, char c)
{
	int l = rlen(s);
	s = realloc(s, (l + 2));
	sprintf(s+l,"%c",c);
	return s;
}


//	   .........................................		//
char *make_verb(struct list *l)
{
	char *s = 0;
	if (verb) {
		if (is_question)
			s = rwhole(0,sq, fit_verb(), description(isstate(VERB,l)));
		else
			s = rwhole(0, fit_verb(), description(isstate(VERB,l)), 0);
		s = rwhole(s," ?", 0, 0);
	}
	return s;
}


//	   .........................................		//
static int is (char *s1, char *s2)
{
	return !strcmp(s1, s2) ? 1 : 0;
}


//	   .........................................		//
static char *fit_mi(char *s)
{
	if (is("mi",s))
		return "Ci";
	else if (is("ci",s))
		return "mi";
	else if (is("nam",s))
		return "wam";
	else if (is("wam",s))
		return "nam";
	return s;
}


//	   .........................................		//
static char *fit_mnie(char *s)
{
	if (is("mnie",s))
		return "tobie";
	else if (is("tobie",s) || is("cie",s))
		return "mnie";
	else if (is("nas",s))
		return "was";
	else if (is("was",s))
		return "nas";
	return s;
}


//	   .........................................		//
static char *fit_mna(char *s)
{
	if (is("mna",s))
		return "tob";
	else if (is("toba",s))
		return "mn";
	else if (is("nami",s))
		return "wami";
	else if (is("wami",s))
		return "nami";
	return s;
}


//	   .........................................		//
static char *fit_moj(char *s)
{
	if (is("moj",s) || is("muj",s))
		return "twoj";
	else if (is("twoj",s) || is("twuj", s))
		return "moj";
	else if (is("nasz",s))
		return "wasz";
	else if (is("wasz",s))
		return "nasz";
	return s;
}


//	   .........................................		//
static char *fit_moji(char *s)
{
	if (is("moji",s) || is("moi",s))
		return "twoji";
	else if (is("twoji",s) || is("twoi", s))
		return "moji";
	else if (is("nasi",s))
		return "wasi";
	else if (is("wasi",s))
		return "nasi";
	return s;
}


// i would keep it in file zaimki or sth.		prowizorka :)
//	   .........................................		//
static char *fit_polski(char *s)
{
	s = fit_mi(s);
	s = fit_mnie(s);
	s = fit_mna(s);
	s = fit_moji(s);
	s = fit_moj(s);
	if (is("ze",s))
		s = "z";
	return s;
}


//	   .........................................		//
static int is_word(struct list *l, char *s)
{
	struct w *jmp;
	for (jmp = l->first; jmp; jmp = jmp->next) 
		if (is(s, jmp->caption))
				return 1;
	return 0;
}


//	   .........................................		//
void set_states(int i, char *s)
{
	if (i < KRZYKNIK)
		is_question++;
	if (i < PYTAJNIK)
		sq = s;
}


//	   .........................................		//
int set_patch(struct w * jmp, char *s)
{
	if (is("dlaczego", s))
		jmp->state = CZEMU;
	else if (is("czym", s))
		jmp->state = KIM;
	else if (strstr("jak", s))
		jmp->state = JAK;
	if (jmp->state)
		set_states(jmp->state, s);	
	return jmp->state;
}


//	   .........................................		//
void set_flags(struct list *l)
{
	struct w *jmp;
	struct word *www;
	char *s;
	int awi, bi;
	for (sq = 0,is_question = 0, verb = 0, jmp = l->first; jmp; jmp = jmp->next) {
		s = jmp->caption;
		for (awi = FIRST_ASKW + 1; awi < LAST_ASKW; awi++)
			if (is(ask_word[awi],s))  {
				jmp->state = awi;
				set_states(awi, s);	
				break;
			}
		if (!jmp->state)
			if (!set_patch(jmp,s))
				if (!test_be(jmp))  
					if (!test_have(jmp))
						for (bi = FIRST_BASE+1; bi < LAST_BASE; bi++) {
							www = rwdefin(bi, s, brosser);
							if (www) {
								if (bi == VERB && !verb) 
									verb = www;		
								jmp->state = bi;
							}
						}
		if (!jmp->state)
			jmp->state = NIEZNANY;
	}
}


//	   .........................................		//
static struct w* isstate(int state, struct list *l)
{
	struct w * jmp = l->first;
	for (;jmp; jmp = jmp->next)
		if (jmp->state == state)
			return jmp;
	return 0;
}


//	   .........................................		//
char *pass_answer(struct phrase *p)
{
	if (!p) {
		fprintf(stderr,"phrase is empty");
		return "blah";
	} else {
		struct word *jmp;
		int i;
		if (mood == HOSTILE)
			p->current = p->hostile;
		else if (mood == FRIENDLY) 
			p->current = p->friendly;
		else 
			p->current = p->neutral;
		i = d(p->current->n);
		for (jmp = p->current->first; --i && jmp; jmp = jmp->next);
		return jmp->what;
	}
}


//	   .........................................		//
static char *description(struct w *jmp)
{
	char *desc = 0, *s;
	int prev = 0; // was previous && strlen of previous
	
	for (jmp = jmp->next; jmp; jmp = jmp->next, prev++) 
		if (jmp->state != PYTAJNIK) {
			s = fit_polski(jmp->caption);
			prev = (desc) ? strlen(desc) : 0 ;
			desc = realloc(desc, (prev + strlen(s)+2));
			sprintf(desc+prev,"%s%s",(prev) ?  " " : "", s);
		}
	return desc;
	
}


//	   .........................................		//
static int rlen(char *s)
{
	return (s) ? strlen(s) : 0;
}


//	   .........................................		//
static char *rstr(char *s)
{
	return (s) ? s :"";
}







//////////////////////////////////////////////////////////////////////////////////////////////
//			 B E
//////////////////////////////////////////////////////////////////////////////////////////////


//	   .........................................		//
static int test_be(struct w *jmp)
{
	int i = 1;
	char **j2 = be_words+i;
	for (; **j2 != '|'; j2++, i++)
		if (is(small2(*j2), jmp->caption)) {
			jmp->state = BYC;
			jmp->byc = i;
		}
	return jmp->byc;
	
}


//	   .........................................		//
static char *fit_be(int bc)
{
	if (bc == JESTEM)
		bc = JESTES;
	else if (bc == JESTES)
		bc = JESTEM;
	else if (bc == JESTESMY)
		bc = JESTESCIE;
	else if (bc == JESTESCIE)
		bc = JESTESMY;
	return be_words[bc];	
}


//	   .........................................		//
static char *rbe(struct w *byc, char *ans)
{
	char *desc = description(byc);
	char *sb = pass_answer(is_phrase(crosser,BE_HAVE));
	char *per = fit_be(byc->byc);
	return rwhole(ans, sb, per, desc);
}


//	   .........................................		//
static char *with_be(struct list *l, struct w *byc)
{
	char *ans = 0, *h1 = 0;
	
	if (isstate (CO, l)) {
		h1 = "co ? Niegrzecznie tak pyta !";
		ans = malloc(sizeof(char) * (strlen(h1) + 2));
		sprintf(ans,"%s", h1);
	} else if (isstate(KIM, l)) {
		if (byc->byc == JESTES)
			return pprintf("nazywam si %s i jestem androidem",name);	
		h1 = pass_answer(is_phrase(crosser,WHO));
		ans = malloc(sizeof(char) * (strlen(h1) + 1));
		sprintf(ans,"%s ", h1);
		ans = rbe(byc, ans);
	
	} else if (isstate(CZEMU, l)) {
		h1 = pass_answer(is_phrase(crosser,PROBLEM));
		ans = malloc(sizeof(char) * (strlen(h1) + 1));
		sprintf(ans,"%s ", h1);
		ans = rbe(byc, ans);
	} else
		ans = rbe(byc, ans);
	return ans;
}



//////////////////////////////////////////////////////////////////////////////////////////
//			H A V E
//////////////////////////////////////////////////////////////////////////////////////////


//	   .........................................		//
static char *fit_have(int bc)
{
	if (bc == MAM)
		bc = MASZ;
	else if (bc == MASZ)
		bc = MAM;
	else if (bc == MAMY)
		bc = MACIE;
	else if (bc == MACIE)
		bc = MAMY;
	return have_words[bc];	
}


//	   .........................................		//
static int test_have(struct w *jmp)
{
	int i = 0;
	char **j2 = have_words;
	for (; **j2 != '|'; j2++, i++)
		if (is(small2(*j2), jmp->caption))  {
			 jmp->state = MIEC;
			 jmp->miec = i;
		}
	return jmp->miec;
}


//	   .........................................		//
static char *rhave(struct w *miec, char *ans)
{
	char *desc = description(miec);
	char *per = fit_have(miec->miec);
	return rwhole(ans, per, desc, 0);
}


//	   .........................................		//
static char *with_have(struct list *l, struct w *miec)
{
	char *ans = 0, *h1 = 0;
	
	if (isstate (ILE, l)) {
		h1 = "niewiem ile";
		ans = rwhole(ans,h1, 0,  0);
		ans = rhave(miec, ans);
	} else if (isstate(CZEMU, l)) {
		h1 = "Pewnie tak jako wyszo. Czy ty te masz";
		ans = rwhole(ans, h1, description(miec), 0);
	} else if (isstate(JAK, l)) {
		if (miec->miec == MASZ) {
			if (is_word(l,"sie")) {
				h1 = pass_answer(is_phrase(crosser,REGARD));
				observ++;
			}
		} else {
			h1 = "A skd u licha mog to wiedzie ?";
			observ--;
		}
		ans = rwhole(ans, h1, 0, 0);
		return ans;
	} else 
		ans = rhave(miec, ans);
	ans = add_ch(ans, '?');
	if (is_word(l,"problem"))
		ans = rwhole(ans, " Opowiedz mi co to za rodzaj problemu", 0, 0);
	else if (is_word(l,"dosyc") || is_word(l, "dosc"))
		ans = rwhole(ans, " Przykro mi kiedy to slysze! ale dlaczego ?", 0, 0);
		
	return ans;
		
}




//////////////////////////////////////////////////////////////////////////////////////////
//			: )
//////////////////////////////////////////////////////////////////////////////////////////


//	   .........................................		//
char *interpret(struct list *l)
{
	struct w *byc = isstate(BYC,l), *miec = isstate(MIEC, l);
	if (byc)
		return with_be(l, byc);
	else if (miec)
		return with_have(l, miec);
	return 0;
}
