// omentialvo
#include "s_rpass.h"
#include "f_rpass.h"

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

#include <time.h>
#include <ctype.h>

extern char *bname;
char *sdir = "../skeletons";
extern char *read_word(FILE *fd, char *s);
extern struct word *init_word(char *what);
extern int d(int);
struct defin;
struct defin {
	struct word *first, *last;
	struct defin *next;
	int state, n;
	char *question;
};
struct base {
	struct defin *first, *last;
	int ndefin;
};


static struct defin *init_defin()
{
	struct defin *a = malloc(sizeof(struct defin));
	a->first = a->last = 0;
	a->state = a->n = 0;
	a->question = 0;
	a->next = 0;
	
	return a;
}

//----------------------------------------------------------------------------------
struct word * prev_word(struct base *b, struct word *src)
{
	struct defin *d = b->first;
	struct word *w;
	for (; d; d = d->next)
		for (w = d->first; w; w = w->next)
			if (w->next == src)
				return w;
			
	return 0;
}
static void put_word(struct defin *a, char *what)
{
	if (!a->first)
		a->first = a->last = init_word(what);
	else {
		a->last->next = init_word(what);
		a->last = a->last->next;
	}
	a->n++;

}

static struct base *init_base()
{
	struct base *a = malloc(sizeof(struct base));
	a->first = a->last = 0;
	a->ndefin = 0;
	return a;
}

static struct defin *add_defin(struct base *b, int s) 
{
	if (!b->first)
		b->first = b->last = init_defin();
	else {
		b->last->next = init_defin();
		b->last = b->last->next;
	}
	b->ndefin++;
	b->last->state = s;
	return b->last;
}

struct defin *find_defin(struct base *b, int state)
{
	struct defin *d;
	if (!b)
		return 0;
	for (d = b->first; d; d = d->next)
		if (d->state == state)
			return d;
	return 0;
}

char *rand_word(struct defin *dd)
{
	int i = d(dd->n);
	struct word *w = dd->first;
	for (i--; i; i--, w = w->next);
	return w->what;
		
}

struct word *rwdefin(int state, char *s, struct base *b)
{
	struct defin *d = find_defin(b, state);
	struct word *jmp; 		// it`s more handsome, like a stairs
	int i = 1;
	if (d)
		for (jmp = d->first; jmp; jmp = jmp->next, i++) 
			if (!strcmp(s, jmp->what))
				return jmp;
	return 0;
}

int wdefin(int state, char *s, struct base *b)
{
	struct defin *d = find_defin(b, state);
	struct word *jmp; 		// it`s more handsome, like a stairs
	int i = 1;
	if (d)
		for (jmp = d->first; jmp; jmp = jmp->next, i++) 
			if (strstr(s, jmp->what))
				return i;
	return 0;
}

char *sname(char *p1,char *p2)
{
	char *r = malloc(sizeof(char) * (strlen(p1) + strlen(p2) +2));
	sprintf(r,"%s/%s",p1, p2);
	return r;
}
//----------------------------------------------------------------------------------
extern char *pprintf(char *s, char *w);

// sorry i know this function is too big. FORGIVE ME !!!
struct base *add_base(char *fname, int patch) 
{
	char dir[50];
	char *whole_name = sname(sdir, fname);
	FILE *fd = fopen(whole_name,"r"); 
	struct defin *current = 0;
	if (!fd) {
		fprintf(stderr, "Can`t open file %s/%s into dir %s\n", 
			dir, fname, getcwd(dir, 50));
		whole_name = sname(PREFIX, fname);
		
		fd = fopen(sname(whole_name, fname), "r");
		if (!fd) {
			fprintf(stderr, "Can`t open file %s/%s into dir %s\n",	
				sdir, fname, getcwd(dir, 50));
			abort();
		}
	} if (fd) {
		struct base *brosser = (patch) ? add_base(bname, 0) : init_base();
		int line, state;
		char *whole, *msg = 0;
		fprintf(stderr,"file %s : ", whole_name);
 		for (whole = read_word(fd, "\n"), line = 1;
			whole && !msg; whole = read_word(fd, "\n"), line++) {
			state = 0;
			
			if (*whole == '#' || strlen(whole) < 2)
				continue;
			else if (*whole == '@') {
				if (brosser->last)
					brosser->last->question = (whole+1);
				else 
					msg = pprintf("question without part "
						"of base definition","");
			} else if (*whole == '$') {
				whole++;
				if (!strcmp("confirmation", whole)) 
					state = CONFIRMATION;
				else if (!strcmp("refusal", whole))
					state = REFUSAL;
				else if (!strcmp("offence", whole))
					state = OFFENCE;
				else if (!strcmp("execration", whole))
					state = EXECRATION;
				else if (!strcmp("honour", whole)) 
					state = HONOUR;
				else if (!strcmp("bye", whole)) 
					state = BYE;
				else if (!strcmp("verb", whole)) 
					state = VERB;
				else 
					msg = pprintf("not defied word '%s'",whole);
				if (state) {
					current = find_defin(brosser, state);
					if (!current) 
						current = add_defin(brosser, state);
				}
			} else 
				put_word(current, whole);
		}
		fclose(fd);
		if (msg) {
			fprintf(stderr, "in lines %d is %s\n", line, msg);
			abort();
		}
		fprintf(stderr, ":D");
		return brosser;
	}
	return 0;
}

